#! /usr/bin/mzscheme -qr

;The Trubble Ticket System
;See README.txt for licence details
;Copyright (C) 2002 MJ Ray and Luminas Ltd

; configuration details
(define ticketdir "./")
(define ticketfile (string-append ticketdir "/tickets.scm"))

; modules we use
(require
  (lib "xml.ss" "xml")
  (lib "cgi.ss" "net"))

(output-http-headers)

(write-xml/content
  (xexpr->xml
    `(html
       (head (title "Trouble Tickets"))
       (body
         (h1 "Trouble Ticket Index")
         (ul
             ,@(let* ((tickets (read (open-input-file ticketfile))))
                 (map (lambda (ticket)
                        (let ((num (car ticket))
                              (flags (cadr ticket))
                              (subj (caddr ticket))
                              (owner (cadddr ticket)))
                          `(li
                               (a ((href ,(number->string num))) " " ,subj)
                               " - assigned to " ,owner
                               " with flags "
                               (b ,(format "~A" flags)))))
                   tickets)))))))
